
#define BLYNK_PRINT Serial
#include <ESP8266WiFi.h>
#include <BlynkSimpleEsp8266.h>
#include <DHT.h>


char auth[] = ""; //Authentication token from blynk
char ssid[] = ""; // Wifi name
char pass[] = ""; //wifi password

#define DHTPIN 2          
#define DHTTYPE DHT11   

int door1 = 12; //GPIO5 D6 Pin number on which door sensor is connected
int door2 = 14; //GPIO15 D5

void myTimerEvent(){ //function for door status indication for AC1
  if(digitalRead(door1) == 0){ // door closed
    Blynk.virtualWrite(V0, "AC1 OFF"); //print the status on the display widget in blynk project
     Blynk.virtualWrite(V2, LOW);
  }
  else 
  if(digitalRead(door1) == 1){
    Blynk.virtualWrite(V0, "AC1 ON");
     Blynk.virtualWrite(V2, HIGH);
  }
  }
  void myTimerEvent2(){ //function for door status indication for AC2
  if(digitalRead(door2) == 0){
    Blynk.virtualWrite(V1, "AC2 OFF");
     Blynk.virtualWrite(V3, LOW);
  }else 
  if(digitalRead(door2) == 1)
  {
    Blynk.virtualWrite(V1, "AC2 ON");
     Blynk.virtualWrite(V3, HIGH);
  }
  }
DHT dht(DHTPIN, DHTTYPE);
BlynkTimer timer;
void sendSensor()
{                             //function for the DHT sensor
  float h = dht.readHumidity();
  float t = dht.readTemperature(); 

  if (isnan(h) || isnan(t)) {
    Serial.println("Failed to read from DHT sensor!");
    return;
  }
  Blynk.virtualWrite(V5, h); //show the value on the labeld value widget at blynk project
  Blynk.virtualWrite(V6, t);
}

int relay= D7; //D7 //to control the board for AC1
int relay2=15; //D8 //to control the board for AC2
    
BLYNK_WRITE(V2){ //the virtual button V2 in blynk project
  int pinData = param.asInt(); //method that returns the button state when its clicked
  if (pinData == 1){ // to turn AC on
    digitalWrite(relay,LOW);
    delay(1000);
    digitalWrite(relay,HIGH);
  }else{ // 3 clicks to turn the AC off
    digitalWrite(relay,LOW);
    delay(1000);
    digitalWrite(relay,HIGH);
    delay(1000);

    digitalWrite(relay,LOW);
    delay(1000);
    digitalWrite(relay,HIGH);
    delay(1000);
    
    digitalWrite(relay,LOW);
    delay(1000);
    digitalWrite(relay,HIGH);
    }
  }

BLYNK_WRITE(V3){ //for the second AC
  int pinData = param.asInt(); //method that returns the button state when its clicked
  
  if (pinData == 1){
    digitalWrite(relay2,LOW);
    delay(1000);
    digitalWrite(relay2,HIGH);
        
  }else{
    
    digitalWrite(relay2,LOW);
    delay(1000);
    digitalWrite(relay2,HIGH);
    delay(1000);

    digitalWrite(relay2,LOW);
    delay(1000);
    digitalWrite(relay2,HIGH);
    delay(1000);
    
    digitalWrite(relay2,LOW);
    delay(1000);
    digitalWrite(relay2,HIGH);
    }
}
BLYNK_WRITE(V4){ //virtual button to turn both ACs ON
  int pinData = param.asInt();
  if (pinData == 1){
    if(digitalRead(door1)==0){ //if off
     Blynk.virtualWrite(V0, "AC1 ON"); //make it on
     Blynk.virtualWrite(V2, HIGH);
      digitalWrite(relay,LOW);
      delay(1000);
      digitalWrite(relay,HIGH);
      }
   if(digitalRead(door2)==0) {
     Blynk.virtualWrite(V1, "AC2 ON");
     Blynk.virtualWrite(V3, HIGH);
     digitalWrite(relay2,LOW);
     delay(1000);
     digitalWrite(relay2,HIGH);
   }    
   } 
   }
BLYNK_WRITE(V7){ ////virtual button to turn both ACs OFF
  int pinData = param.asInt();
  if (pinData == 1){
    if(digitalRead(door1) == 1){ //check if the AC's door is on/open
     Blynk.virtualWrite(V0, "AC1 OFF"); //make it off
     Blynk.virtualWrite(V2, LOW);
      digitalWrite(relay,LOW);
      delay(1000);
      digitalWrite(relay,HIGH);
      delay(1000);

      digitalWrite(relay,LOW);
      delay(1000);
      digitalWrite(relay,HIGH);
      delay(1000);

      digitalWrite(relay,LOW);
      delay(1000);
      digitalWrite(relay,HIGH);
    } 
    if(digitalRead(door2)==1) {
      Blynk.virtualWrite(V1, "AC2 OFF");
     Blynk.virtualWrite(V3, LOW);
        digitalWrite(relay2,LOW);
        delay(1000);
        digitalWrite(relay2,HIGH);
        delay(1000);
        
        digitalWrite(relay2,LOW);
        delay(1000);
        digitalWrite(relay2,HIGH);
        delay(1000);

        digitalWrite(relay2,LOW);
        delay(1000);
        digitalWrite(relay2,HIGH);
    }     
  } 
}
void setup()
{
   pinMode(door1, INPUT_PULLUP);
   pinMode(door2, INPUT_PULLUP);
   pinMode(relay, OUTPUT); // set relay pin as output
   pinMode(relay2, OUTPUT);
   digitalWrite(relay,HIGH); 
   digitalWrite(relay2,HIGH); 

  // Debug console
  Serial.begin(9600);
  Blynk.begin(auth, ssid, pass);
  
  // Setup a function to be called every second
  timer.setInterval(1000L, myTimerEvent);
  timer.setInterval(1000L, myTimerEvent2);
  timer.setInterval(1000L, sendSensor);
  dht.begin();

  
}

void loop()
{
  Blynk.run();
  timer.run();
}
